package net.binzume.android.nicoplayer;

import java.util.List;

import net.binzume.android.nicoplayer.api.*;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

public class MyListActivity extends ListActivity  {
    
    private MyList mylist;
    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.wait);

        Intent intent = getIntent();
        if (intent.getStringExtra("list") == null) {
            final List<MyList> list = MyListAPI.getLists(NicoPlayerTop.session);
            AlertDialog.Builder dlg = new AlertDialog.Builder(this);
            String names[] = new String[list.size()];
            for (int i=0;i<list.size();i++) {
                names[i] = list.get(i).name;
            }
            dlg.setItems(names, new DialogInterface.OnClickListener(){
                public void onClick(DialogInterface dialog, int which) {
                    MyListTask getlist = new MyListTask(MyListActivity.this);
                    getlist.execute(list.get(which));
                }
            });
            dlg.setOnCancelListener(new DialogInterface.OnCancelListener() {
                public void onCancel(DialogInterface dialog) {
                    MyListActivity.this.finish();
                }
            });
            dlg.setTitle("}CXg");
            dlg.show();
            
            return;
        }
        
        MyListTask getlist = new MyListTask(this);
        getlist.execute();
        
    }
    
    public void setMylist(MyList mylist) {
        if (mylist == null) {
            finish();
            return;
        }
        this.mylist = mylist;
        setContentView(R.layout.video_list);
        MyListAdapter adapter = new MyListAdapter(this, R.layout.video_row, mylist);
        setListAdapter(adapter);

        MyListThumbnailTask thumbtask = new MyListThumbnailTask();
        thumbtask.execute(adapter);

        getListView().setOnItemLongClickListener(new AdapterView.OnItemLongClickListener(){
            @Override
            public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
                Log.v("nicoplayer","mylist menu "+ position);
                final int pos = position;
                String names[] = new String[2];
                names[0] = "Remove!!";
                names[1] = "Cancel";
                AlertDialog.Builder dlg = new AlertDialog.Builder(MyListActivity.this);
                dlg.setItems(names, new DialogInterface.OnClickListener(){
                    public void onClick(DialogInterface dialog, int which) {
                        if (which==0) {
                            MyListAPI.remove(NicoPlayerTop.session, MyListActivity.this.mylist, MyListActivity.this.mylist.items.get(pos).id);
                            MyListTask getlist = new MyListTask(MyListActivity.this);
                            getlist.execute(MyListActivity.this.mylist);
                        }
                    }
                });
                dlg.setOnCancelListener(new DialogInterface.OnCancelListener() {
                    public void onCancel(DialogInterface dialog) {
                        MyListActivity.this.finish();
                    }
                });
                dlg.show();
                return false;
             }
         });
    }

    @Override
    protected void onListItemClick(ListView l, View v, int pos, long id) {
        Log.d("nicop","click"+pos);

        Intent intent=new Intent(this,Player.class);
        intent.setAction("start");
        intent.putExtra("vid", mylist.items.get(pos).videoId);
        startActivity(intent);
    }

}
