package net.binzume.android.nicoplayer;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;
import net.binzume.android.nicoplayer.api.*;

public class MyListAdapter extends ArrayAdapter<MyList.Item> {

    private MyList mylist;
    private Bitmap thumbImges[];
    LayoutInflater inflater;
    public MyListAdapter(Context context, int resource,
           MyList mylist) {
        super(context, resource, mylist.items);
        
        this.mylist = mylist;
        thumbImges = new Bitmap[mylist.items.size()];
        this.inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    @Override
    public View getView(int position, View v, ViewGroup parent) {
        
        if (v == null) {
            v = inflater.inflate(R.layout.video_row, null);  
        }
        
        TextView titleText = (TextView)v.findViewById(R.id.title);
        titleText.setText(mylist.items.get(position).title);

        ImageView tumbnailImage = (ImageView)v.findViewById(R.id.video_thumb);
        if (thumbImges[position]!=null) {
            tumbnailImage.setImageBitmap(thumbImges[position]);
        } else {
            tumbnailImage.setImageResource(R.drawable.icon);
        }
        
        return v;
    }
    
    public MyList getMyList(){
        return mylist;
    }
    
    public void setThumbnail(int pos,Bitmap img) {
        thumbImges[pos] = img;
        notifyDataSetChanged();
    }
    
}
