/**
 * Đ
 * 
 * Ő
 * 
 * @author binzume <kawahira__binzume.net>
 */

package net.binzume.android.nicoplayer;

import java.net.URLEncoder;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import net.binzume.android.nicoplayer.api.*;
import net.binzume.android.nicoplayer.proxy.SmilevideoCache;
import net.binzume.android.nicoplayer.proxy.SmilevideoCacheManager;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.Rect;
import android.media.AudioManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.widget.Button;
import android.widget.EditText;
import android.widget.MediaController;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.VideoView;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;

public class Player extends Activity {

    private SmilevideoCache cache;
    
    Handler handler = new Handler();
    private class CommentItem {
        final static public int STYLE_SHITA = 1;
        final static public int STYLE_UE = 2;
        final static public int STYLE_BIG = 4;
        final static public int STYLE_SMALL = 8;
        public CommentInfo ci;
        public CommentView textView;
        public int entryTime;
        public int y;
        public int color;
        public int style;
    }
    private List<CommentItem> items;
    private class CommentView extends TextView {
        public CommentView(Context context) {
            super(context);
        }
        
    }
    private List<CommentView> comentview_stock = new LinkedList<CommentView>();
    private Uri url;
    private String vid;
    private int width;
    private ThreadInfo threadInfo;
    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        if (getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        } else {
            getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
        setVolumeControlStream(AudioManager.STREAM_MUSIC);

        setContentView(R.layout.buffering);

        Intent intent = getIntent();
        vid = intent.getStringExtra("vid");

        // vLVT[rXJn
//        Intent intent2=new Intent(this,SmileVideoProxyService.class);
//        intent2.setAction("start");
//        startService(intent2);

        if (!SmilevideoCacheManager.isCacheAvailable()) {
            new AlertDialog.Builder(this)
            .setTitle("G[")
            .setMessage("SDɃANZXłȂC܂")
            .setPositiveButton("OK",new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    Player.this.finish();
                }
            })
            .show();
        } else {
            // load
            ((TextView)this.findViewById(R.id.WaitingText)).setText("Loading...(VideoInfo)");
            PlayerVideoInfoTask c = new PlayerVideoInfoTask(this);
            c.execute(NicoPlayerTop.session, vid);
        }
    }

    @Override
    protected void onStop() {
        Log.d("nicoplayer"," stop thread");
        if (cache!=null) {
            cache.close();
            cache=null;
        }
        super.onStop();
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        menu.add(Menu.NONE, 1, Menu.NONE, "Ƃ肠}CXgǉ");
        menu.add(Menu.NONE, 2, Menu.NONE, "Rg");
        return super.onCreateOptionsMenu(menu);
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId()==1) {
            MyListAPI.addDefault(NicoPlayerTop.session,vid);
        }
        if (item.getItemId()==2) {
            post();
        }
        return true;
    }
    
    public void comment(ThreadInfo ti){
        

        // Rg
        items = new LinkedList<CommentItem>();
        if (ti != null ) {
            for (Iterator<CommentInfo> i = ti.comments.iterator(); i.hasNext();) {
                CommentInfo ci = i.next();
                CommentItem item = new CommentItem();
                item.ci=ci;
                item.entryTime = ci.vpos*10 - 2000;
                if (item.entryTime<0) item.entryTime = 0;
                item.color = Color.WHITE;
                items.add(item);
                String command[] = ci.mail.split("\\s");
                for (int j=0;j<command.length;j++) {
                    if (command[j].equals("red")) item.color = Color.RED;
                    else if (command[j].equals("blue")) item.color = Color.BLUE;
                    else if (command[j].equals("green")) item.color = Color.GREEN;
                    else if (command[j].equals("purple")) item.color = Color.rgb(0x9b, 0x1d, 0x68);
                    else if (command[j].equals("cyan")) item.color = Color.CYAN;
                    else if (command[j].equals("yellow")) item.color = Color.YELLOW;
                    else if (command[j].equals("white")) item.color = Color.WHITE;
                    else if (command[j].equals("black")) item.color = Color.BLACK;
                    else if (command[j].equals("pink")) item.color = Color.rgb(0xf1, 0x8d, 0x99);
                    else if (command[j].equals("orange")) item.color = Color.rgb(0xe9, 0x79, 0x16);
                    else if (command[j].equals("shita")) item.style|=CommentItem.STYLE_SHITA;
                    else if (command[j].equals("ue")) item.style|=CommentItem.STYLE_UE;
                    else if (command[j].equals("small")) item.style|=CommentItem.STYLE_SMALL;
                    else if (command[j].equals("big")) item.style|=CommentItem.STYLE_BIG;
                }
            }
            Collections.sort(items, new Comparator<CommentItem>() {
                public int compare(CommentItem a, CommentItem b) {
                    return a.entryTime-b.entryTime;
                }
            });
            threadInfo = ti;
            threadInfo.comments = null; // Rs[̂łgȂ
        }
        if (url != null) {
            ((TextView)this.findViewById(R.id.WaitingText)).setText("Loading...(Buffering)");
            new Runnable() {
                @Override
                public void run() {
                    TextView tv = ((TextView)Player.this.findViewById(R.id.WaitingText));
                    if (tv==null) return;
                    if (cache!=null && cache.getSize()>0)
                        tv.setText("Loading...(Buffering "+(long)cache.getCacheSize()*100/cache.getSize()+"%)");
                    if (cache!=null && cache.type != null && !"video/mp4".equals(cache.type)) {
                        new AlertDialog.Builder(Player.this)
                            .setTitle("G[")
                            .setMessage("Ή̌`ł(mp4̂ݍĐł܂)")
                            .setPositiveButton("OK",new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int which) {
                                    Player.this.finish();
                                }
                            })
                            .show();
                        return;
                    }
                    if (cache!=null && cache.isComplete) {
                        setContentView(R.layout.player);
                        play();
                        return;
                    }
                    if (cache!=null && cache.getSize()>0 &&
                            (long)cache.getCacheSize()>4*1024*1024) {
                        ((Button)Player.this.findViewById(R.id.Button01)).setVisibility(View.VISIBLE);
                        ((Button)Player.this.findViewById(R.id.Button01)).setOnClickListener( new View.OnClickListener(){
                            public void onClick(View v) {
                                Player.this.setContentView(R.layout.player);
                                Player.this.play();
                            }
                        });
                    }
                    handler.postDelayed(this, 100);
                }
            }.run();
        }
        
    }
    public void videoInfo(HashMap<String, String> flvInfo){
        String videoUrl = flvInfo.get("url");
        String cookie = "user_session="+NicoPlayerTop.session.user_session
             + "; nicohistory=" + NicoPlayerTop.session.history;

        Log.d("nicoplayer",cookie);
        cookie = "nicohistory=" + NicoPlayerTop.session.history;
        
        String param = URLEncoder.encode(videoUrl + "#" + cookie);
        url = Uri.parse("http://localhost:25251/video/" + param);

        
        SmilevideoCacheManager.startServer();
        
        
        cache = SmilevideoCacheManager.getCache(flvInfo.get("_vid"));
        cache.startDownload(videoUrl,cookie);

        ((TextView)this.findViewById(R.id.WaitingText)).setText("Loading...(Comment)");
        PlayerCommentLoadTask c = new PlayerCommentLoadTask(this);
        c.execute(NicoPlayerTop.session,new VideoInfo(flvInfo));
    }
    
    private void post(){
        VideoView videoView = (VideoView)Player.this.findViewById(R.id.VideoView01);
        final boolean isPlaying = videoView.isPlaying();
        if (isPlaying) {
            videoView.pause();
        }
        final EditText comment = new EditText(this);
        comment.setSingleLine();
        new AlertDialog.Builder(this)
        .setTitle("RgM")
        .setView(comment)
        .setPositiveButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                VideoView videoView = (VideoView)Player.this.findViewById(R.id.VideoView01);
                int vpos = videoView.getCurrentPosition()/10;
                CommentAPI.postComment(NicoPlayerTop.session, threadInfo, vpos, comment.getText().toString());
                if (isPlaying) {
                    videoView.start();
                }
            }
        })
        .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int whichButton) {
                VideoView videoView = (VideoView)Player.this.findViewById(R.id.VideoView01);
                if (isPlaying) {
                    videoView.start();
                }
            }
        })
        .show();
    }

    private void play(){
        final VideoView videoView = (VideoView)findViewById(R.id.VideoView01);
        videoView.requestFocus();
        videoView.setMediaController(new MediaController(this));

        ((RelativeLayout)findViewById(R.id.RelativeLayout02))
         .setOnClickListener(new View.OnClickListener(){
            public void onClick(View v) {
                VideoView videoView = (VideoView)findViewById(R.id.VideoView01);
                if (videoView.isPlaying()) {
                    videoView.pause();
                } else {
                    videoView.start();
                    
                }
            }

        });
        
        if (cache.isComplete) {
            videoView.setVideoPath(cache.getPath());
        } else {
            videoView.setVideoURI(url);
        }
        RelativeLayout marqueeLayer = (RelativeLayout)findViewById(R.id.MarqueeLayer);

        for (int i=0;i<30;i++) {
            CommentView tv = new CommentView(this);
            comentview_stock.add(tv);
            marqueeLayer.addView(tv,600,500);
            tv.setText("");
            tv.setTextSize(20);
            tv.setSingleLine(true);
            tv.setShadowLayer(1,0,0,Color.BLACK);
        }
        

        width = -1;

        new Runnable() {
            @Override
            public void run() {
                tick();
                handler.postDelayed(this, 100);
            }
        }.run();
        
        videoView.start();
        
    }
    
    public void tick() {
        VideoView videoView = (VideoView)findViewById(R.id.VideoView01);
        if (!videoView.isPlaying()) {
            return;
        }
        Rect r = new Rect();
        videoView.getGlobalVisibleRect(r);
        int height = videoView.getHeight();
        if (width != videoView.getWidth()) {
            RelativeLayout btn = ((RelativeLayout)findViewById(R.id.RelativeLayout02));
            ViewGroup.LayoutParams lp = btn.getLayoutParams();
            lp.width = ViewGroup.LayoutParams.FILL_PARENT;
            lp.height = height*2/3;
            btn.setLayoutParams(lp);

            width = videoView.getWidth();
            //@Rgׂ
            int rowslot1[] = new int[height/24]; // sXbg󂭎
            int rowslot2[] = new int[height/24]; // sXbg󂭎
            int rowslot3[] = new int[height/24]; // ue,shitap
            for (Iterator<CommentItem> i = items.iterator(); i.hasNext();) {
                CommentItem ci = i.next();
                ci.y = (int)(Math.random()*(height-24));
                if ((ci.style&CommentItem.STYLE_SHITA)!=0) {
                    for (int j=rowslot3.length-1;j>=0;j--) {
                        if (rowslot3[j] <= ci.entryTime) {
                            rowslot3[j] = ci.entryTime+4000;
                            ci.y = j*24;
                            break;
                        }
                    }
                } else if ((ci.style&CommentItem.STYLE_UE)!=0) {
                        for (int j=0;j<rowslot3.length;j++) {
                            if (rowslot3[j] <= ci.entryTime) {
                                rowslot3[j] = ci.entryTime+4000;
                                ci.y = j*24;
                                break;
                            }
                        }
                } else {
                    for (int j=0;j<rowslot1.length;j++) {
                        int w = (ci.ci.message.length()*20*4000/width);
                        if (rowslot1[j] <= ci.entryTime && rowslot2[j] <= ci.entryTime+4000-w) {
                            rowslot1[j] = ci.entryTime+w;
                            rowslot2[j] = ci.entryTime+4000;
                            ci.y = j*24;
                            break;
                        }
                    }
                }
                //Log.d("nicoplayer","slot " +ci.y+" "+ ci.entryTime);
            }
            
        }
        
        int t = videoView.getCurrentPosition();
        //Log.d("nicoplayer","time: " + t);

        for (Iterator<CommentItem> i = items.iterator(); i.hasNext();) {
            CommentItem ci = i.next();
            if (ci.entryTime<=t && t<ci.entryTime+4000) {
                if (ci.textView==null) {
                    if (comentview_stock.size()>0) {
                        CommentView tv = comentview_stock.get(0); // get
                        comentview_stock.remove(0);
                        ci.textView = tv;
                        tv.setText(ci.ci.message);
                        tv.setTextColor(ci.color);
                    } else {
                        continue;
                    }
                }
                int x;
                if ((ci.style&CommentItem.STYLE_SHITA)==0) {
                    x=width-(t-ci.entryTime)*(width+ci.ci.message.length()*20)/(width+3500);
                } else {
                    x=(width-ci.ci.message.length()*20)/2;
                }
                ci.textView.setPadding(x,ci.y,0,0);
            } else if (ci.textView != null) {
                ci.textView.setText("");
                comentview_stock.add(ci.textView); // return
                ci.textView=null;
            }
        } 
    
    }
    
    
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        if (newConfig.orientation == Configuration.ORIENTATION_LANDSCAPE) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        } else {
            getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
    }

}
