package net.binzume.android.nicoplayer;

import java.util.List;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;
import net.binzume.android.nicoplayer.api.*;

public class VideoListActivity extends ListActivity  {
    
    private List<VideoInfo> videolist;
    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //setContentView(R.layout.video_list);
        setContentView(R.layout.wait);
        ((TextView)this.findViewById(R.id.WaitingText)).setText("Loading...");

        Intent intent = getIntent();
        if ("tag".equals(intent.getStringExtra("mode"))) {
            TagSearchTask search = new TagSearchTask(this);
            search.execute(intent.getStringExtra("keyword"));
            this.setTitle("tag:" + intent.getStringExtra("keyword"));
        } else {
            RankingTask ranking = new RankingTask(this);
            ranking.execute("");
        }
    }
    
    @Override
    protected void onListItemClick(ListView l, View v, int pos, long id) {
        Log.d("nicop","click"+pos);

        Intent intent=new Intent(this,Player.class);
        intent.setAction("start");
        intent.putExtra("vid", videolist.get(pos).videoId);
        startActivity(intent);
    }
    
    public void loaded(List<VideoInfo> result){
        if (result==null) {
            finish();
            return;
        }
        setContentView(R.layout.video_list);

        videolist = result;
        VideoListAdapter adapter = new VideoListAdapter(this, R.layout.video_row, videolist);
        setListAdapter(adapter);

        VideoListThumbnailTask thumbtask = new VideoListThumbnailTask();
        thumbtask.execute(adapter);
    
    }

}
