package net.binzume.android.nicoplayer;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.List;
import net.binzume.android.nicoplayer.api.VideoInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Handler;

public class VideoListThumbnailTask extends AsyncTask<VideoListAdapter,Integer,Integer>{

    Handler handler;

    public VideoListThumbnailTask() {
        handler = new Handler();
    }

    @Override
    protected Integer doInBackground(VideoListAdapter... params) {
        final VideoListAdapter adapter = params[0];
        List<VideoInfo> list = adapter.getList();
        
        for (int i=0;i<list.size();i++) {
            if (list.get(i).thumbnailUrl == null) break;
            try {
                //Log.d("nicoplayer","thumbnail: "+mylist.items.get(i).thumbnailUrl);
                URL url = new URL(list.get(i).thumbnailUrl);
                InputStream is = url.openStream();
                final int pos = i;
                final Bitmap bm = BitmapFactory.decodeStream(is);
                is.close();
                handler.post(new Runnable() {
                    @Override
                    public void run() {
                        adapter.setThumbnail(pos, bm);
                    }
                });
            } catch (IOException e) {
            }
        }
        return null;
    }

}
