package net.binzume.android.nicoplayer.api;

import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.*;

import android.util.Log;

public class SearchAPI {
    public static final String API_URL = "http://www.nicovideo.jp/tag/";

    public static List<VideoInfo> getByTag(String tag){
        Log.d("nicoplayer_api","tag search ");
        HttpClient client = new HttpClient();
 
        if(!client.get(API_URL + URLEncoder.encode(tag) +"?rss=2.0")){
            return null;
        }

        String data = client.getContent();
        if(data.length() <= 0){
            return null;
        }

        
        ArrayList<VideoInfo> list = new ArrayList<VideoInfo>();

        //int i=0;

        Pattern pattern1 = Pattern.compile("<item>\\s*(.*?)</item>",Pattern.DOTALL);
        Pattern pattern = Pattern.compile("<title>([^<]+)</title>\\s*<link>([^<]+)</link>");
        Pattern pattern2 = Pattern.compile("<p class=\"nico-thumbnail\"><img [^>]*?src=\"([^\"]+)");
        Matcher matcher1 = pattern1.matcher(data);
        while (matcher1.find()) {
            //Log.d("nicoplayer_api","ranking " + matcher1.group(1) );
            Matcher matcher = pattern.matcher(matcher1.group(1));
            if (matcher.find()){
                VideoInfo v = new VideoInfo();
                v.title =  matcher.group(1);
                v.url =  matcher.group(2);
                //Log.d("nicoplayer_api","ranking " + matcher.group(2) );
                String a[] = matcher.group(2).split("/");
                v.videoId =  a[a.length-1];

                matcher = pattern2.matcher(matcher1.group(1));
                if (matcher.find()){
                    v.thumbnailUrl = matcher.group(1);
                }

                list.add(v);
                //if (++i>40) break;
            }
        }

        return list;
    }
}
