// LbVt@Cւ̃ANZX

package net.binzume.android.nicoplayer.proxy;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.io.FileNotFoundException;

import net.binzume.android.nicoplayer.proxy.SmilevideoCacheServer.DownloadThread;

import android.os.Environment;
import android.util.Log;

public class SmilevideoCache {
    public String vid;
    public boolean isComplete;
    public boolean isError = false;
    public boolean availavle;
    public long size;
    public long orgsize;
    public String type;
    
    private RandomAccessFile file;
    static final String cache_dir = "/net.binzume.android.nicoplayer";
    
    private DownloadThread dlThread;
    private DownloadThread rangeDlThread;
    private String dir;
    private String path;

    SmilevideoCache(String vid) {
        this.vid = vid;
        isComplete = false;
        try {
            dir = Environment.getExternalStorageDirectory().getPath() + cache_dir;
            File f = new File(dir + "/" + vid + ".mp4");
            if (f.isFile()) {
                isComplete = true;
                path = dir + "/" + vid + ".mp4";
                orgsize = f.length();
            } else {
                path = dir + "/_" + vid + ".mp4";
                loadInfo();
            }
            file = new RandomAccessFile(path,"rw");
            size = file.length();
            if (orgsize==0) orgsize = file.length();
        } catch (FileNotFoundException e) {
            Log.d("nicop_SmileVideoProxy","create cache failed");
        } catch (IOException e) {
            Log.d("nicop_SmileVideoProxy","create cache failed");
        }
    }
    
    public void close() {
        try {
            stopDownload();
            file.close();
            saveInfo();
        } catch (IOException e) {
        }
    }
    
    public boolean startDownload(String url, String cookie) {
        if (isComplete) return false;
        dlThread = new DownloadThread(this,url,cookie);
        dlThread.start();
        return true;
    }
    
    public void stopDownload() {
        if (dlThread != null) {
            dlThread.interrupt();
            dlThread = null;
        }
        if (rangeDlThread != null) {
            rangeDlThread.interrupt();
            rangeDlThread = null;
        }
    }
    
    
    public int getSize() {
        return (int)orgsize;
    }

    public int setSize(int size) {
        orgsize = size;
        return (int)orgsize;
    }
    
    public String getPath() {
        return path;
    }
    
    private void saveInfo(){
        try{
            File f = new File(dir + "/" + vid + ".info");
            BufferedWriter writer = new BufferedWriter(new FileWriter(f));
            writer.write("size=" + orgsize + "\n");
            writer.close();
        } catch (IOException e) {
            
        }
    }
    private void loadInfo(){
        try{
            File f = new File(dir + "/" + vid + ".info");
            BufferedReader reader = new BufferedReader(new FileReader(f));
            String line;
            while((line=reader.readLine()) != null) {
                String kv[] = line.split("=");
                if (kv.length<2) continue;
                if (kv[0].equals("size")) {
                    orgsize = Integer.parseInt(kv[1]);
                } else if (kv[0].equals("vid")) {
                    vid = kv[1];
                }
            }
        } catch (IOException e) {
            
        }
    }
    
    public int getCacheSize(){
        return (int)size;
    }

    public int read(byte[] buffer,int offset,int length) {
        return readwrite(buffer,offset,length,0);
    }

    public int write(byte[] buffer,int offset,int length) {
        return readwrite(buffer,offset,length,1);
    }
    
    private synchronized int readwrite(byte[] buffer,int offset,int length, int mode) {
        try {
            if (mode==0) {
                file.seek(offset);
                return file.read(buffer,0,length);
            } else if (mode==1) {
                file.seek(offset);
                file.write(buffer,0,length);
                if (offset+length>size) size = offset+length;
                if (size>=orgsize) {
                    String newpath = dir + "/" + vid + ".mp4";
                    file.close();
                    File f = new File(path);
                    f.renameTo(new File(newpath));
                    path = newpath;
                    file = new RandomAccessFile(path,"rw");
                    isComplete=true;
                }
                return length;
            }
        } catch (IOException e) {
        }
        return -1;
    }
    

}
