package net.binzume.android.nicoplayer.proxy;

import java.io.File;

import android.os.Environment;

public class SmilevideoCacheManager {

    static final String cache_dir = "/net.binzume.android.nicoplayer";
    private static SmilevideoCacheServer server;

    public static boolean isCacheAvailable(){
        if (!Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED))
            return false;
        File dir = new File(Environment.getExternalStorageDirectory().getPath() + cache_dir);
        dir.mkdirs();
        return true;
    }

    public static SmilevideoCache getCache(String vid){
        if (!isCacheAvailable()) {
            return null;
        }
        SmilevideoCache cache = new SmilevideoCache(vid);
        if (server!=null) {
            server.setCache(cache);
        }
        return cache;
    }
    
    public static void releaseCache(SmilevideoCache cache) {
        if (server!=null) {
            server.setCache(null);
        }
        cache.close();
    }
    
    public static void startServer(){
        if (server==null) {
            server = new SmilevideoCacheServer(null);
        }
        if (!server.isAlive() ) {
            server.start();
        }
    }
    public static void stopServer(){
        server.interrupt();
    }

}
