package net.binzume.android.nicoplayer.proxy;
import android.content.Context;
import android.net.Uri;
import android.util.Log;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;  
import java.io.OutputStreamWriter;
import java.net.ServerSocket;  
import java.net.Socket;  
import java.net.URLDecoder;
import java.io.BufferedOutputStream;
import java.io.BufferedInputStream;

public class SmilevideoProxyThread  extends Thread {
    
    static final String cachedir = "/net.binzume.android.nicoplayer";

    static final int DEFAULT_PORT = 25251;
    
    public SmilevideoProxyThread(Context context) {
    }

    @Override
    public void run() {
        Log.d("nicoplayer_SmileVideoProxy","start");
        
        ServerSocket server = null;
        try {
            server = new ServerSocket(DEFAULT_PORT);
            for (int i=0;;i++) {
                // ڑ󂯕t܂ő҂
                Socket client = server.accept();
                ConnectionThread ct = new ConnectionThread(client, i);
                ct.start();
            }
        } catch (Exception e) {
            try {
                if (server != null) server.close();
            } catch (Exception ee) {
            }
        }
        Log.d("nicoplayer_SmileVideoProxy","finish");
    }

    class ConnectionThread extends Thread {
        Socket client;
        int counter;
  
        public ConnectionThread(Socket client, int c) {
            this.client = client;
            this.counter = c;
        }

        // vLV
        public void run() {
            
            
            BufferedOutputStream os = null;
            BufferedInputStream sockin = null;
            BufferedWriter sockout = null;
            try {
                //@NCAg@IP
                String destIP = client.getInetAddress().toString();
                // NCAg@|[g  
                int destport = client.getPort();

                Log.d("nicoplayer_SmileVideoProxy","accept Connection " + counter + " Fconnected from "  
                        + destIP + " with port " + destport + ".");

                if (!destIP.equals("/127.0.0.1")) {
                    Log.d("nicoplayer_SmileVideoProxy"," not local IP.");
                    return;
                }

                os = new BufferedOutputStream(client.getOutputStream());
                BufferedReader reader = new BufferedReader(new InputStreamReader(client.getInputStream()));

                // NGXg
                String inline = reader.readLine();
                String request[] = inline.split(" ");
                if (request.length < 2 || !request[1].substring(0,7).equals("/video/")) {
                    Log.d("nicoplayer_SmileVideoProxy","invalid url");
                    return;
                }
                String url = URLDecoder.decode(request[1].substring(7));
                String request2[] = URLDecoder.decode(request[1].substring(7)).split("#");
                url = request2[0];
                String cookie = request2[1];
                // url = "http://nicogame.jp/test.mp4";
                Log.d("nicop","smilevideo connect ok " + url);
                

                // ڑ
                Uri uri = Uri.parse(url);
                Socket soc = new Socket(uri.getHost(),uri.getPort()<0?80:uri.getPort());
                Log.d("nicoplayer_SmileVideoProxy","socket ok");

                sockin = new BufferedInputStream(soc.getInputStream());
                sockout = new BufferedWriter(new OutputStreamWriter(soc.getOutputStream()));
                sockout.write(request[0]+" " + uri.getPath()+"?"+uri.getQuery() + " HTTP/1.1\r\n");


                Log.d("nicoplayer_SmileVideoProxy","Header recv start ");
                
                while (reader.ready() && inline != null) {                  
                    inline = reader.readLine();
                    Log.d("nicop_SmileVideoProxy","recv: "+inline);
                    if (inline.length()>10 &&  inline.substring(0,5).equals("Host:")){
                        Log.d("nicop_SmileVideoProxy","cookie: "+cookie );
                        sockout.write("Host:" + uri.getHost() + "\r\n");
                        sockout.write("Cookie:" + cookie + "\r\n");
                        continue;
                    }
                    sockout.write(inline + "\r\n");
                    if (inline.length()==0) {
                        break;
                    }
                }
                sockout.write("\r\n");
                sockout.flush();
                Log.d("nicop_SmileVideoProxy","Header recv ok ");
                
                
                // ]
                byte buf[] = new byte[4096];
                int len;
                while((len = sockin.read(buf))>0){
                    //Log.d("nicop_SmileVideoProxy","recv:"+len);
                    os.write(buf,0,len);
                }
                Log.d("nicop_SmileVideoProxy","smilevideo end ");

                os.close();
                sockout.close();
                sockin.close();
                soc.close();
            } catch (Exception e) {  
                try{
                    if (sockout!=null) sockout.close();
                    if (sockin!=null) sockin.close();
                    if (os!=null) os.close();
                } catch (Exception ee) {  
                }
                for (int i=0;i<e.getStackTrace().length;i++) {
                    Log.d("nicop_SmileVideoProxy","Exception:"+e.getStackTrace()[i]);
                }
            }
            Log.d("nicop_SmileVideoProxy","connection end");
        }
        
    }
}
